float timestep = 1;
float gravity = 100;
float radius = 200;
float initv = 1.0 * sqrt(gravity / radius);

float cx, cy;
Ball sun, earth;
color sunout = color(255,255,55);
color sunin = sunout;
color earthout = color(0,255,0);
color earthin = color(0,0,255);

void setup() {
  size(720,720);
  cx = width/2;
  cy = height/2;
  sun = new Ball(cx, cy, 0, 0, 20);
  sun.inner = sunin;
  sun.outer = sunout;
  earth = new Ball(cx, cy - radius, initv, 0, 10);
  earth.inner = earthin;
  earth.outer = earthout;
  noStroke();
  background(0);
}

void draw() {
//  background(0);
//  earth.inner = earth.outer = earthout;
//  earth.display();
  earth.move();
//  earth.inner = earth.outer = earthin;
  earth.display();
  sun.display();
  println("Frames: ",frameCount);  
}

class Ball {
  float x, y, vx, vy;
  float diameter;
  color inner = 0;
  color outer = 255;
 
  Ball(float xin, float yin, float vxin, float vyin, float din) {
    x = xin;
    y = yin;
    vx = vxin;
    vy = vyin;
    diameter = din;
  } 
  
  void display() {
    fill(outer);
    ellipse(x, y, diameter, diameter);
    fill(inner);
    ellipse(x, y, diameter * 0.5, diameter * 0.5);
  }
  
  void move() {
    
    float dx = x - cx;
    float dy = y - cy;
    float r = sqrt(dx * dx + dy * dy);
    float a = gravity/(r * r);
    x += vx * timestep;
    y += vy * timestep;
    vx -= a * (dx/r) * timestep;
    vy -= a * (dy/r) * timestep;
  }
}
